# fop-project (1.0) Changes

http://xmlgraphics.apache.org/fop/ fop-project ( 1.0 ) Changes en-us

# fop-project Renderers fix

http://xmlgraphics.apache.org/fop/Renderers fix by JM : AFP Output: Fixed positioning of Java2D-based images (when GOCA is enabled).

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by JM : AFP Output: Added enhanced dithering functionality for images that are converted to bi-level images.

# fop-project Renderers fix

http://xmlgraphics.apache.org/fop/Renderers fix by JM : AFP Output: Fix for bitmap images inside an SVG or G2D graphic (printer errors) and positioning fix for bitmaps from G2D graphics.

# fop-project Renderers fix (bug 42306)

http://xmlgraphics.apache.org/fop/Renderers fix by JM (fixes bug 42306) : Fix for AWT viewer to correctly track page numbers in continuous display mode. Thanks to Richard Wheeldon.

# fop-project Renderers fix

http://xmlgraphics.apache.org/fop/Renderers fix by JM : Bugfix for formatting of floating point numbers which could lead to invalid PDFs.

# fop-project Renderers fix

http://xmlgraphics.apache.org/fop/Renderers fix by JM : Added a save/restoreGraphicsState pair for the initial coordinate system in PDF output for easier post-processing.

# fop-project Images add

http://xmlgraphics.apache.org/fop/Images add by JM : Added customization ability for the image loading framework from FOP's configuration file.

# fop-project Renderers fix (bug 48696)

http://xmlgraphics.apache.org/fop/Renderers fix by JM (fixes bug 48696) : Bugfix for color model in IOCA IDE structure parameter for 4- and 8-bit grayscale images. Thanks to Peter Hancock.

# fop-project Renderers add (bug 48567)

http://xmlgraphics.apache.org/fop/Renderers add by JM (fixes bug 48567) : Initial support for CID-keyed double-byte fonts (Type 0) in AFP output. Thanks to Peter Hancock.

# fop-project API add

http://xmlgraphics.apache.org/fop/API add by SP : Added a command-line option '-catalog' to use a catalog resolver for the XML and XSLT files

# fop-project Layout add

http://xmlgraphics.apache.org/fop/Layout add by SP : Implement internal character classes if the hyphenation pattern file does not contain them

# fop-project Layout fix (bug 46486)

http://xmlgraphics.apache.org/fop/Layout fix by VH (fixes bug 46486) : Bugfix: having a special page-master for the last page caused loss of content when normal blocks were mixed with blocks spanning all columns.

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by VH : Added possibility to customize PDF tagging via the ‘role’ property.

# fop-project Renderers fix (bug 48237)

http://xmlgraphics.apache.org/fop/Renderers fix by CB (fixes bug 48237) : Bugfix: AFP Renderer: Respect image color settings for svg Thanks to Peter Hancock.

# fop-project Renderers fix (bug 48376)

http://xmlgraphics.apache.org/fop/Renderers fix by CB (fixes bug 48376) : Bugfix: AFP Renderer: Page Overlays not generated when using Intermediate Format Thanks to Venkat Reddy.

# fop-project Renderers fix (bug 48456)

http://xmlgraphics.apache.org/fop/Renderers fix by CB (fixes bug 48456) : Bugfix: AFP Renderer: Underline is incorrectly placed when reference-orientation != 0

# fop-project Renderers fix (bug 48453)

http://xmlgraphics.apache.org/fop/Renderers fix by CB (fixes bug 48453) : Bugfix: AFP Renderer: Page Segments not positioned correctly when reference-orientation != 0

# fop-project Fonts add

http://xmlgraphics.apache.org/fop/Fonts add by JM : Added support for TrueType fonts with symbol character maps (like "Wingdings" and "Symbol"). Character for these fonts are usually found in the 0xF020 to 0xF0FF range (a Unicode private use area).

# fop-project Fonts fix

http://xmlgraphics.apache.org/fop/Fonts fix by JM : Bugfix: Font selection fallbacks did not work in some cases (ex. bold+italic to normal)

# fop-project Renderers fix (bug 48290)

http://xmlgraphics.apache.org/fop/Renderers fix by CB (fixes bug 48290) : Bugfix: AFP Renderer: AttributeQualifier Triplet occurs before TLE Value.

# fop-project Renderers fix (bug 48048)

http://xmlgraphics.apache.org/fop/Renderers fix by JM (fixes bug 48048) : Bugfix in AFP output: fixed flags in GOCA GBAR order. Thanks to D.W. Harks.

# fop-project Renderers fix (bug 48185)

http://xmlgraphics.apache.org/fop/Renderers fix by VH (fixes bug 48185) : Bugfix in AFP output: rounding error when computing the CMYK components of a color. Thanks to Harald G. Henne.

# fop-project Code fix (bug 48167)

http://xmlgraphics.apache.org/fop/Code fix by VH (fixes bug 48167) : Bugfix: when #CMYK pseudo-profile was used in the rgb-icc() function, always the fallback RGB colors were used instead. Thanks to Venkat Reddy.

# fop-project Layout fix (bug 48082)

http://xmlgraphics.apache.org/fop/Layout fix by VH (fixes bug 48082) : Bugfix: value of conditional space not always taken into account in the calculation of a table’s height.

# fop-project Renderers add (bug 46705)

http://xmlgraphics.apache.org/fop/Renderers add by JM,VH (fixes bug 46705) : Added basic accessibility and Tagged PDF support. Thanks to Jost Klopfstein.

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by JM : Added support for encoding CMYK bitmap images (IOCA FS45) and TIFF images as embedded objects.

# fop-project Code add

http://xmlgraphics.apache.org/fop/Code add by AC : Added support for xmlfile and xsltfile parameters in FOP's Ant Task.

# fop-project Renderers fix (bug 47941)

http://xmlgraphics.apache.org/fop/Renderers fix by AC (fixes bug 47941) : BugFix: Maintain valid AFP by providing TLE truncation on Attribute Value Triplet values that are greater than 250 chars in length.

# fop-project Fonts fix (bug 47711)

http://xmlgraphics.apache.org/fop/Fonts fix by JM (fixes bug 47711) : Fixed generation of CIDSet object in PDF output. Thanks to Nicolas Peninguy.

# fop-project Layout fix

http://xmlgraphics.apache.org/fop/Layout fix by VH : Fixed handling of percentage values for provisional-label-separation.

# fop-project Layout fix (bug 47835)

http://xmlgraphics.apache.org/fop/Layout fix by VH (fixes bug 47835) : Fixed handling of percentage values for provisional-distance-between-starts. Thanks to Jonathan Levinson.

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by CB : Added support for positioning Page Overlays in AFP Output

# fop-project Fonts add

http://xmlgraphics.apache.org/fop/Fonts add by JM : Added support for specifying referenced fonts per renderer in addition to the general match list.

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by JM : Added support for creating thumbnails or preview bitmaps of fixed size for PNG and TIFF output.

# fop-project Extensions add

http://xmlgraphics.apache.org/fop/Extensions add by JM : Added support for the #CMYK pseudo-profile supported by some commercial XSL implementations on the rgb-icc() function.

# fop-project Layout add

http://xmlgraphics.apache.org/fop/Layout add by VH : Added limited support for pages of different inline-progression-dimensions within a page-sequence.

# fop-project Layout add (bug 46905)

http://xmlgraphics.apache.org/fop/Layout add by AD (fixes bug 46905) : Added basic implementation for column-keeps.

# fop-project Code fix (bug 47710)

http://xmlgraphics.apache.org/fop/Code fix by AD (fixes bug 47710) : White-space handling in markers with inline-content throws a NullPointerException in some cases.

# fop-project Renderers fix (bug 47694)

http://xmlgraphics.apache.org/fop/Renderers fix by CB (fixes bug 47694) : Dithered Background Shading can produce illegal AFP if objects are very small

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by CB : AFP Output: Added support for IMM Extension on fo:simple-page-master.

# fop-project Renderers add (bug 47311)

http://xmlgraphics.apache.org/fop/Renderers add by JM (fixes bug 47311) : Added an initial set of extensions for prepress support (fox:bleed, fox:crop-offset, fox:crop-box and fox:scale). This is currently supported only by PDF and Java2D renderers. Thanks to Peter Coppens.

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by JM : PCL Output: Added support for specifying the output bin.

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by JM : AFP Output: Added support for embedding external AFP form maps (form defs) using the afp:include-form-map extension.

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by JM : AFP Output: Added support for AFP font embedding. Note: this changes the default behaviour. Like with PDF and PS, all fonts are embedded by default unless matched in the "referenced-fonts" section in the configuration.

# fop-project Renderers fix (bug 47508)

http://xmlgraphics.apache.org/fop/Renderers fix by AD (fixes bug 47508) : Bugfix: Error while writing TLE's attribute qualifier in the output. Thanks to Bharat Attaluri.

# fop-project Renderers fix

http://xmlgraphics.apache.org/fop/Renderers fix by CB : Bugfix: support justified text in AFP Renderer (already working in AFP Painter)

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by AD : AFP Renderer Raster Fonts: added support for fractional font-sizes in the configuration. selection of the smaller font-size, in case two possible fallbacks have the same difference to a requested size.

# fop-project Fonts fix

http://xmlgraphics.apache.org/fop/Fonts fix by CB : Bugfix: support PFM Files with no extent table.

# fop-project Code fix (bug 46960)

http://xmlgraphics.apache.org/fop/Code fix by AD (fixes bug 46960) : Bugfix: previously retrieved markers were not cleared if the new marker was empty.

# fop-project Fonts fix (bug 47232)

http://xmlgraphics.apache.org/fop/Fonts fix by VH (fixes bug 47232) : Bugfix: for the last character of a Type1 font, always a width of 0 was returned. Thanks to Maxim Wirt.

# fop-project Code fix

http://xmlgraphics.apache.org/fop/Code fix by VH : Changed meaning of ‘-v’ option to ‘verbose’, which will print FOP’s version and proceed. Added a ‘-version’ option to simply print the version then exit, following Java practices.

# fop-project Layout fix (bug 47101)

http://xmlgraphics.apache.org/fop/Layout fix by VH (fixes bug 47101) : Bugfix: The cells of a table inside a marker were duplicated at every marker retrieval.

# fop-project Images fix

http://xmlgraphics.apache.org/fop/Images fix by JM : Bugfix: use the effective color profile supplied by the ImageEncodingHelper, instead of the original one.

# fop-project Renderers fix

http://xmlgraphics.apache.org/fop/Renderers fix by JM : Bugfix: reset graphic state when a page is finished in PostScript.

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by JM : Added setting to enable dithered painting of filled rectangles in AFP and PCL.

# fop-project Layout fix

http://xmlgraphics.apache.org/fop/Layout fix by VH : Bugfix: footnotes occurring within the forced height of a table row did not appear on the output

# fop-project Renderers update (bug 47031)

http://xmlgraphics.apache.org/fop/Renderers update by JM (fixes bug 47031) : PDFGraphics2D.writeClip doesn't generate a clip command anymore when the clip path is empty. Thanks to Francois Fernandes.

# fop-project Renderers add (bug 47000)

http://xmlgraphics.apache.org/fop/Renderers add by JM (fixes bug 47000) : Added a custom text painter for rendering SVG text using text operators when rendering to PostScript or EPS. Text is no longer painted as shapes, thus creating much smaller files.

# fop-project Renderers fix

http://xmlgraphics.apache.org/fop/Renderers fix by JM : Fixed a bug that left the PrintRenderer unconfigured even if a configuration was specified for "application/X-fop-print".

# fop-project Renderers fix (bug 46882)

http://xmlgraphics.apache.org/fop/Renderers fix by JM (fixes bug 46882) : Fixed the handling of CMYK colors in PDFGraphics2D. Thanks to Yegor Kozlov.

# fop-project Layout fix (bug 46489)

http://xmlgraphics.apache.org/fop/Layout fix by AD (fixes bug 46489) : Fixed a bug when combining a forced break with a "last" page-master. The restart of the algorithm would start at the index of the penalty corresponding to the last page-break. This has been changed to the index of the first element after the last page-break.

# fop-project Fonts add

http://xmlgraphics.apache.org/fop/Fonts add by JM : Added a command-line tool to list all configured fonts (org.apache.fop.tools.fontlist.FontListMain).

# fop-project Code add (bug 46828)

http://xmlgraphics.apache.org/fop/Code add by AD (fixes bug 46828) : Added the possibility to use CachedRenderPagesModel, to conserve memory in case of large documents with a lot of cross-references (area tree will be serialized to disk to avoid keeping it entirely in memory). Thanks to Dario Laera.

# fop-project Fonts add

http://xmlgraphics.apache.org/fop/Fonts add by JM : AFP Fonts: Added support for full URI resolution on configured AFP fonts.

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by JM : AFP Output: Tag Logical Element (TLE) is now also allowed on fo:page-sequence (page group level).

# fop-project Layout fix

http://xmlgraphics.apache.org/fop/Layout fix by JM : Fixed BPD trait and border painting for leaders with leader-pattern="space" (and similar cases).

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by JM : AFP Output: Added support for Invoke Medium Map (IMM).

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by JM : Introduced a new, additional intermediate format optimized for performance. Please see the intermediate format documentation for details.

# fop-project Fonts fix (bug 46686)

http://xmlgraphics.apache.org/fop/Fonts fix by JM (fixes bug 46686) : Use temporary directory for the font cache if the user home directory is not write-accessible. Thanks to Alok Singh.

# fop-project Renderers fix (bug 45342)

http://xmlgraphics.apache.org/fop/Renderers fix by JM (fixes bug 45342) : AFP Fonts: Fixed interpretation of metric for fonts with fixed metrics and made sure all repeating groups in FNP (Font Position) are processed. Thanks to Emil Maskovsky.

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by JM : AFP Output: Added a configuration option to override the resource level defaults in the code.

# fop-project Code fix (bug 46638)

http://xmlgraphics.apache.org/fop/Code fix by VH (fixes bug 46638) : MinOptMaxUtil.toMinOptMax was converting LengthRangeProperty objects into illegal MinOptMax objects (in some cases opt could be inferior to min).

# fop-project Layout add (bug 46315)

http://xmlgraphics.apache.org/fop/Layout add by VH (fixes bug 46315) : Added extension to disable column balancing before blocks spanning the whole page, in multiple-column documents. Thanks to Georg Datterl.

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by JM : AFP Output: Bilevel images in resource groups as generated as hard page segments (instead of image objects) for better interoperability with older IPDS environments and for better printing performance.

# fop-project Fonts add

http://xmlgraphics.apache.org/fop/Fonts add by JM : FOP now creates ToUnicode CMaps for single-byte fonts that don't use built-in encodings to help PDF text extractors interpreting characters.

# fop-project Fonts add

http://xmlgraphics.apache.org/fop/Fonts add by JM : Added support for forcing single-byte encodings for TrueType fonts without creating an XML font metric file (see "encoding-mode" attribute on "font" element)

# fop-project Layout fix (bug 45306)

http://xmlgraphics.apache.org/fop/Layout fix by JM (fixes bug 45306) : Fixed fo:instream-foreign-object inside fo:marker.

# fop-project Renderers fix

http://xmlgraphics.apache.org/fop/Renderers fix by JM : Fixed black backgrounds occurring for transparent images in PCL output.

# fop-project Renderers fix (bug 46369)

http://xmlgraphics.apache.org/fop/Renderers fix by CB (fixes bug 46369) : Fixed bug that caused AFP Renderer Extensions to be ignored.

# fop-project Code fix (bug 46319)

http://xmlgraphics.apache.org/fop/Code fix by AD (fixes bug 46319) : Fixed a memory-leak in Marker.MarkerAttribute, where an instance was used both as key and value in a WeakHashMap, effectively neutralizing the benefit of using WeakReferences. Solved by extending PropertyCache to work for MarkerAttributes as well.

# fop-project Renderers fix

http://xmlgraphics.apache.org/fop/Renderers fix by JM : Fixed a multi-threading issue when rendering SVG.

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by AC : AFP Output: An AFPGraphics2D implementation which provides the ability to use Batik to drive the production of AFP Graphics (GOCA) output from SVG.

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by AC : AFP Output: Resource group leveling, external streaming, and de-duplication of images and graphics using IncludeObject and ResourceGroup.

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by AC : AFP Output: Native image embedding support (e.g. JPEG, GIF, TIFF) using ObjectContainer and a MOD:CA Registry implementation.

# fop-project Fonts fix

http://xmlgraphics.apache.org/fop/Fonts fix by AC : More robust AFP font parsing, although it is still in need of some rework in the future.

# fop-project Images add (bug 41657)

http://xmlgraphics.apache.org/fop/Images add by JM (fixes bug 41657) : Added support for SVG 1.2 functionality inside fo:instream-foreign-object.

# fop-project Layout fix (bug 46240)

http://xmlgraphics.apache.org/fop/Layout fix by AD (fixes bug 46240) : Fixed a bug when combining break-before with a span change.

# fop-project Code fix (bug 46211)

http://xmlgraphics.apache.org/fop/Code fix by AD (fixes bug 46211) : Fixed some multi-threading issues in FontCache.java: remove the unused private readObject() make the changeLock member final (initialization-safety + impossible to reassign) perform the HashMap check for a failed font inside the synchronized block to avoid a race condition Thanks to rogov.AT.devexperts.com.

# fop-project Renderers add (bug 45113)

http://xmlgraphics.apache.org/fop/Renderers add by AD (fixes bug 45113) : Added PDF /Launch action: references to URIs using the file:// protocol will now generate a /Launch action as opposed to a more general /URI (which doesn't yield the expected result for this protocol). Thanks to Alexander Stamenov.

# fop-project Layout fix

http://xmlgraphics.apache.org/fop/Layout fix by JM : Fixed a problem where the BPD or a block area could be wrong if there is a nested, absolutely positioned area (for example a block-container).

# fop-project Code fix (bug 45971)

http://xmlgraphics.apache.org/fop/Code fix by VH (fixes bug 45971) : Improved the behaviour of the command line interface. Thanks to Tow Browder.

# fop-project Layout fix (bug 40798)

http://xmlgraphics.apache.org/fop/Layout fix by AD (fixes bug 40798) : Bugzilla 40798: A conditional-page-master-reference with page-position="last" qualifies for a first page, if it is also the last. Additionally: also added support for page-position="only".

# fop-project Code fix (bug 45842)

http://xmlgraphics.apache.org/fop/Code fix by AD (fixes bug 45842) : Make fop.bat and fop.cmd use the %FOP_OPTS% environment variable. Thanks to Carsten Siedentop.

# fop-project Renderers add (bug 45795)

http://xmlgraphics.apache.org/fop/Renderers add by JM (fixes bug 45795) : PDF Output: Added support for handling 16-bit alpha channel. They are currently converted to 8 bits.

# fop-project Renderers fix

http://xmlgraphics.apache.org/fop/Renderers fix by JM : PDF Output: Made sure the XMP Metadata stream is never compressed.

# fop-project Fonts fix (bug 45734)

http://xmlgraphics.apache.org/fop/Fonts fix by JM (fixes bug 45734) : Fix for PFMReader after bug #43089 changed the behavior of PFMFile. Fixes baseline problems when Type 1 fonts are used in conjunction with XML font metric files. Thanks to J. Frantzius.

# fop-project Renderers fix (bug 45616)

http://xmlgraphics.apache.org/fop/Renderers fix by JM (fixes bug 45616) : Fix for table handling in RTF output, so the output works with OpenOffice and AbiWord, too. Thanks to Pavel Kysilka.

# fop-project Code fix (bug 45667)

http://xmlgraphics.apache.org/fop/Code fix by AD (fixes bug 45667) : Quick-fix to avoid a possible NullPointerException when using empty inlines and hyphenation.

# fop-project Layout add

http://xmlgraphics.apache.org/fop/Layout add by JM : Added missing generation of areas for empty grid units in tables with collapsing border model.

# fop-project Code fix

http://xmlgraphics.apache.org/fop/Code fix by JM : Fixed memory leak in property cache (not cleaning stale PropertyCache$CacheEntry instances).

# fop-project Renderers fix

http://xmlgraphics.apache.org/fop/Renderers fix by JM : Fixed text stroking in SVG when the stroke-width is zero.

# fop-project Layout fix

http://xmlgraphics.apache.org/fop/Layout fix by JM : Fixed the source for a division by zero when the content of an fo:leader with leader-pattern="use-content" collapses to zero width during layout.

# fop-project Renderers fix

http://xmlgraphics.apache.org/fop/Renderers fix by JM : Fixed border trait parsing for the area tree XML when CMYK or ICC colors were used.

# fop-project Renderers fix (bug 45606)

http://xmlgraphics.apache.org/fop/Renderers fix by JM (fixes bug 45606) : Fixed generation of "fonttbl" for RTF output to fix loading problem with AbiWord. Thanks to Pavel Kysilka.

# fop-project Layout fix

http://xmlgraphics.apache.org/fop/Layout fix by JM : Fixed ID resolution for nested bookmarks with duplicated IDs.

# fop-project Code fix (bug 45490)

http://xmlgraphics.apache.org/fop/Code fix by AD (fixes bug 45490) : Fixed a slight error when resolving non-file URLs: avoid altering the original 'href' if the protocol is other than 'file:' Thanks to Thomas Stieler.

# fop-project Layout fix (bug 45470)

http://xmlgraphics.apache.org/fop/Layout fix by JM (fixes bug 45470) : Added LayoutManagerMapping.registerMaker() to make registration of custom layout managers easier.

# fop-project Layout fix

http://xmlgraphics.apache.org/fop/Layout fix by LF : Fixed absolute positioning of block-containers when specified using right and bottom instead of left and top.

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by AC : Added PDF encryption parameter support in configuration.

# fop-project Layout add

http://xmlgraphics.apache.org/fop/Layout add by LF : Allowing non-zero borders and padding on page regions when relaxed validation is turned on.

# fop-project Layout fix

http://xmlgraphics.apache.org/fop/Layout fix by LF : Fixed an inconsistency in footnote handling that led to unnecessary empty areas in pages whose last normal line contains footnotes when the page bpd is not the same for all pages.

# fop-project Code update

http://xmlgraphics.apache.org/fop/Code update by AD : Changed FONode.addCharacters() parameter to closer match the signature of the standard SAX characters() event (reduces confusion and computations). !! Implementors of extensions that subclass FONode directly, and offer an implementation for addCharacters() should take care to make similar modifications in their code !!

# fop-project Renderers add (bug 45115)

http://xmlgraphics.apache.org/fop/Renderers add by JM (fixes bug 45115) : Added a PCL-specific extension attribute on simple-page-master for controlling the simplex/duplex mode. Thanks to Martin Edge.

# fop-project Code fix (bug 45097)

http://xmlgraphics.apache.org/fop/Code fix by AD (fixes bug 45097) : Corrected white-space-treatment for situations where an inline-node is the first/last child node of an fo:block, without preceding/following text.

# fop-project Layout add

http://xmlgraphics.apache.org/fop/Layout add by MB : Implemented word-by-ford font-selection strategy on text.

# fop-project Layout add

http://xmlgraphics.apache.org/fop/Layout add by MB : Support character-by-character font-selection strategy on fo:character element.

# fop-project Layout fix (bug 44794)

http://xmlgraphics.apache.org/fop/Layout fix by AD (fixes bug 44794) : Added support for page-number-citation and page-number-citation-last of fo:inline. Corrected behavior for page-number-citation-last of fo:block: forward references now properly resolved.

# fop-project Fonts add

http://xmlgraphics.apache.org/fop/Fonts add by JM : For auto-detected fonts it is now possible to specify that a font needs to be referenced rather than embedded (for the output formats that support this distinction).

# fop-project Layout fix (bug 42423)

http://xmlgraphics.apache.org/fop/Layout fix by AD (fixes bug 42423) : Added support for the "id" attribute on fo:wrappers when used as a child of the fo:flow.

# fop-project Layout fix (bug 41500)

http://xmlgraphics.apache.org/fop/Layout fix by AD (fixes bug 41500) : Fixed a ClassCastException when using an fo:wrapper as a child of an fo:block-container.

# fop-project Fonts add

http://xmlgraphics.apache.org/fop/Fonts add by AC : Add support for font substitution.

# fop-project Renderers fix (bug 43650)

http://xmlgraphics.apache.org/fop/Renderers fix by JM (fixes bug 43650) : PCL Renderer: Improved page format selection so it doesn't interfere with duplex printing.

# fop-project Layout fix (bug 42703)

http://xmlgraphics.apache.org/fop/Layout fix by AD (fixes bug 42703) : Fixed a regression introduced by the fix for Bugzilla 44286.

# fop-project Layout fix (bug 43591)

http://xmlgraphics.apache.org/fop/Layout fix by AD (fixes bug 43591) : Activated min-height/max-height and min-width/max-width properties.

# fop-project Code fix (bug 44203)

http://xmlgraphics.apache.org/fop/Code fix by AD (fixes bug 44203) : Fixed a logic error in Hyphenator.java: If the source had an associated InputStream, an UnsupportedOperationException was triggered.

# fop-project Renderers add (bug 44634)

http://xmlgraphics.apache.org/fop/Renderers add by AD (fixes bug 44634) : Add partial support for the "show-destination" property on fo:basic-link (PDF output only; see limitations on the compliance page)

# fop-project Layout add

http://xmlgraphics.apache.org/fop/Layout add by JM : Added minimal support for integer keep values on the various keep properties on block-level FOs. For now, all integer values are treated the same (i.e. without strength distinction). Using integers allows to avoid overflows that can happen when "always" is used extensively.

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by JM : Added support for rendering pages using JPS (Java Printing System). See new example: examples/embedding/java/ExamplesFO2JPSPrint.java

# fop-project Renderers add (bug 41687)

http://xmlgraphics.apache.org/fop/Renderers add by JM (fixes bug 41687) : Restored ability to specify from/to and odd/even pages as well as the number of copies for printing from the command-line.

# fop-project Renderers add (bug 44678)

http://xmlgraphics.apache.org/fop/Renderers add by JM (fixes bug 44678) : Added ability to pass a preconfigured PrinterJob instance to the PrintRenderer via the rendering options map. Thanks to Antti Karanta.

# fop-project Renderers add (bug 44743)

http://xmlgraphics.apache.org/fop/Renderers add by JM (fixes bug 44743) : Added a public accessor for reference to the current page to PDFGraphics2D. Thanks to Yegor Kozlov.

# fop-project Fonts add (bug 44737)

http://xmlgraphics.apache.org/fop/Fonts add by JM (fixes bug 44737) : Added support for auto-configuring TrueType Collections. XML font metrics files for *.ttc fonts are not required anymore. Thanks to Jason Harrop.

# fop-project Renderers update

http://xmlgraphics.apache.org/fop/Renderers update by JM : When a JPEG image is embedded, an optionally embedded color profile is filtered out as it's already embedded separately in the PDF file.

# fop-project Fonts add

http://xmlgraphics.apache.org/fop/Fonts add by JM : Added support for addressing all glyphs available in a Type 1 font, not just the ones in the font's primary encoding.

# fop-project Code add

http://xmlgraphics.apache.org/fop/Code add by JM : Added an event handling framework which allows to get better feedback from within FOP with the ability to customize problem management.

# fop-project Test fix

http://xmlgraphics.apache.org/fop/Test fix by GA : Fix errors and warnings in example files. Add build.xml for documentation examples.

# fop-project Code fix (bug 53458)

http://xmlgraphics.apache.org/fop/Code fix by GA (fixes bug 53458) : Fix incorrect language and country code key generation in hyphenation tree cache. Thanks to Dieter von Holten.

# fop-project Images fix (bug 53431)

http://xmlgraphics.apache.org/fop/Images fix by GA (fixes bug 53431) : Fix incorrect SVG line dash pattern with PDF output format. Thanks to Luis Bernardo.

# fop-project Images update (bug 40676)

http://xmlgraphics.apache.org/fop/Images update by GA (fixes bug 40676) : Fix interoperability issue with Adobe reader regarding use of multiple filters. Thanks to Luis Bernardo.

# fop-project Code fix

http://xmlgraphics.apache.org/fop/Code fix by GA : Eliminate javadocs warnings.

# fop-project Renderers add (bug 52338)

http://xmlgraphics.apache.org/fop/Renderers add by VH (fixes bug 52338) : Added possibility to embed TrueType fonts in PostScript.

# fop-project Images update (bug 40676)

http://xmlgraphics.apache.org/fop/Images update by GA (fixes bug 40676) : Update site documentation about PNG image loading configuration and support. Thanks to Luis Bernardo.

# fop-project Images update (bug 40676)

http://xmlgraphics.apache.org/fop/Images update by GA (fixes bug 40676) : Fix newly introduced findbugs warnings. Thanks to Luis Bernardo.

# fop-project Images fix (bug 40676)

http://xmlgraphics.apache.org/fop/Images fix by GA (fixes bug 40676) : Support use of ImageLoaderRawPNG decoder in order to prevent re-encoding of PNG images (and unnecssary output file bloat). Thanks to Luis Bernardo, Matthias Reischenbacher.

# fop-project Code fix (bug 53412)

http://xmlgraphics.apache.org/fop/Code fix by GA (fixes bug 53412) : Eliminate incorrect use of object identity which produces excessive property cache collisions. Thanks to Alexios Giotis.

# fop-project Code fix

http://xmlgraphics.apache.org/fop/Code fix by GA : Eliminate javadocs warnings.

# fop-project Code update (bug 53055)

http://xmlgraphics.apache.org/fop/Code update by GA (fixes bug 53055) : Update xmlgraphics common jar to reflect recent fixes in XGC.

# fop-project Code update (bug 43940)

http://xmlgraphics.apache.org/fop/Code update by GA (fixes bug 43940) : Fix handling of NaN, {+,-}Infinity, and other edge cases. Submitted by Julien Aymé. Thanks to Julien Aymé.

# fop-project Renderers fix (bug 53304,53306)

http://xmlgraphics.apache.org/fop/Renderers fix by GA (fixes bug 53304,53306) : Add version attribute to AT and IF intermediate formats. Also eliminate redundant use of reversed attribute in AT format.

# fop-project Renderers fix (bug 53295)

http://xmlgraphics.apache.org/fop/Renderers fix by GA (fixes bug 53295) : Add extension to place code just before PostScript %PageTrailer. Thanks to Luis Bernardo.

# fop-project Renderers fix (bug 53294)

http://xmlgraphics.apache.org/fop/Renderers fix by GA (fixes bug 53294) : Fix invalid PostScript file being created when font-size is 0. Thanks to Robert Meyer.

# fop-project Docs update

http://xmlgraphics.apache.org/fop/Docs update by GA : Update FAQ and New Bug documentation.

# fop-project Code add

http://xmlgraphics.apache.org/fop/Code add by VH : Added support for the role property on fo:page-sequence, fo:flow and fo:static-content. This allows to change the mapping of those FOs to PDF structure types when enabling accessibility.

# fop-project Renderers fix

http://xmlgraphics.apache.org/fop/Renderers fix by VH : Stop outputting the Type entry for structure elements in order to create a smaller PDF ouptut when accessibility is enabled. Thanks to Martin Koegler.

# fop-project Config fix (bug 52144)

http://xmlgraphics.apache.org/fop/Config fix by GA (fixes bug 52144) : Fix crash on use of version switch (-v). Thanks to Luis Bernardo.

# fop-project Renderers fix (bug 53242)

http://xmlgraphics.apache.org/fop/Renderers fix by GA (fixes bug 53242) : Support fractional line widths in AFP renderer, fixing problem with SVG line drawing. Thanks to Luis Bernardo.

# fop-project Config fix (bug 53248)

http://xmlgraphics.apache.org/fop/Config fix by GA (fixes bug 53248) : Fix exception thrown from use of -print option in CLI. Thanks to Luis Bernardo.

# fop-project Docs fix (bug 53247)

http://xmlgraphics.apache.org/fop/Docs fix by GA (fixes bug 53247) : Fix renderer mime type for PCL output; should be application/x-pcl.

# fop-project Renderers fix (bug 40699)

http://xmlgraphics.apache.org/fop/Renderers fix by GA (fixes bug 40699) : Fix for invalid PDF for certain numerical values in SVG lineargradient. Thanks to Luis Bernardo.

# fop-project Layout fix (bug 53185)

http://xmlgraphics.apache.org/fop/Layout fix by GA (fixes bug 53185) : Unify date formatting between FOP and XGC as well as tidying the date format code. Thanks to Robert Meyer.

# fop-project Layout fix (bug 45715)

http://xmlgraphics.apache.org/fop/Layout fix by GA (fixes bug 45715) : Fix for break before (break-before) not respected on blocks nested in inlines. Thanks to Luis Bernardo.

# fop-project Renderers fix (bug 48723)

http://xmlgraphics.apache.org/fop/Renderers fix by GA (fixes bug 48723) : Fix for XGC when rendering PostScript using SVG being drawn upside down when using a custom affine transform. Thanks to Robert Meyer.

# fop-project Code fix (bug 43940)

http://xmlgraphics.apache.org/fop/Code fix by GA (fixes bug 43940) : Use new double format utility to improve thread safety and performance. Thanks to Ognjen Blagojevic.

# fop-project Fonts fix (bug 53148)

http://xmlgraphics.apache.org/fop/Fonts fix by GA (fixes bug 53148) : Fix performance regression in JDK 1.6 Update 19 due to use of Java Beans API. Fix checkstyle errors. Thanks to Tassos Charoulis.

# fop-project Renderers fix (bug 51484)

http://xmlgraphics.apache.org/fop/Renderers fix by GA (fixes bug 51484) : Don't write final /sect suffix in RTF if section is last section. Thanks to Benjamin Riefenstahl.

# fop-project Fonts fix (bug 53143)

http://xmlgraphics.apache.org/fop/Fonts fix by GA (fixes bug 53143) : Ensure fonts are not loaded twice (redundantly).

# fop-project Test update (bug 50196)

http://xmlgraphics.apache.org/fop/Test update by GA (fixes bug 50196) : Add test for basic-link with padding. Thanks to Matthias Reischenbacher.

# fop-project Code update

http://xmlgraphics.apache.org/fop/Code update by GA : Improve property function argument parsing, specifically, better separate required, optional, and variable arguments and the handling of optional argument defaults. Regularize property function class names.

# fop-project Layout fix (bug 51043)

http://xmlgraphics.apache.org/fop/Layout fix by GA (fixes bug 51043) : Don't restart layout unless abs(ipd difference) > 1 in order to prevent rounding issues from triggering false restart. Thanks to Pascal Sancho.

# fop-project Fonts update

http://xmlgraphics.apache.org/fop/Fonts update by GA : Removing experimental feature that violates XSL-FO and Unicode semantics by misinterpreting Basic Latin code points. Users must use private use codepoints to access font specific character mappings that have no assigned Unicode code point. See bug 50492.

# fop-project Layout fix (bug 53103)

http://xmlgraphics.apache.org/fop/Layout fix by GA (fixes bug 53103) : Ensure that table cell spanning works in right-to-left writing mode. Thanks to Matthias Reischenbacher.

# fop-project Layout fix (bug 53086)

http://xmlgraphics.apache.org/fop/Layout fix by GA (fixes bug 53086) : Ensure that table footer and header are included in bididirectional resolution.

# fop-project Layout fix (bug 53097)

http://xmlgraphics.apache.org/fop/Layout fix by GA (fixes bug 53097) : Ensure writing-mode specified on fo:table is used to determine writing mode of table and its descendants.

# fop-project Code fix (bug 53094)

http://xmlgraphics.apache.org/fop/Code fix by GA (fixes bug 53094) : Convert block container overflow exception to event model, improving overflow property behavior. Thanks to Luis Bernardo.

# fop-project Code update (bug 51617)

http://xmlgraphics.apache.org/fop/Code update by GA (fixes bug 51617) : Add run target for embedded examples. Add increased JVM memory heap flag for example8 in case font cache is rebuilt.

# fop-project Code fix (bug 53083)

http://xmlgraphics.apache.org/fop/Code fix by GA (fixes bug 53083) : Update to use of checkstyle-5.5 as default configuration. Remove checkstyle-4.0 configuration. Also, import environment build properties before local properties, so that latter can refer to former.

# fop-project Code fix (bug 52572)

http://xmlgraphics.apache.org/fop/Code fix by GA (fixes bug 52572) : Prevent NPE on use of unsupported collapse-with-precedence; fall back to collapse. Fix checkstyle errors from prior commit. Thanks to Pascal Sancho.

# fop-project Layout fix (bug 52514)

http://xmlgraphics.apache.org/fop/Layout fix by GA (fixes bug 52514) : Ensure square image is appropriately scaled. Thanks to Luis Bernardo.

# fop-project Code fix (bug 50062)

http://xmlgraphics.apache.org/fop/Code fix by GA (fixes bug 50062) : Invoke JVM in headless mode from FOP command scripts and JS shell to prevent stealing focus from GUI applications.

# fop-project Renderers fix (bug 52114)

http://xmlgraphics.apache.org/fop/Renderers fix by GA (fixes bug 52114) : Take leading derived space before/after into account when computing rows for TXT renderer.

# fop-project Code add (bug 49893)

http://xmlgraphics.apache.org/fop/Code add by PH (fixes bug 49893) : A global setting to wrap F11 images in page segments.

# fop-project Code fix (bug 52763)

http://xmlgraphics.apache.org/fop/Code fix by GA (fixes bug 52763) : Support list-block in marker, thus preventing NPE.

# fop-project Code fix

http://xmlgraphics.apache.org/fop/Code fix by GA : Must use unqualified (local name) when reporting invalid child error.

# fop-project Code fix (bug 53065)

http://xmlgraphics.apache.org/fop/Code fix by GA (fixes bug 53065) : Restore lookup on Event message lookup field part. Add locale field to Event to enable locale dependent deferred bundle load during lookup field part substitution.

# fop-project Code fix

http://xmlgraphics.apache.org/fop/Code fix by MH : Bug in AFP font metrics that performed integer arithmetic when it should have been double arithemetic.

# fop-project Code fix (bug 49754)

http://xmlgraphics.apache.org/fop/Code fix by GA (fixes bug 49754) : Bring clone() in line with the recommendations in Object.clone(). Thanks to Simon Pepping.

# fop-project Code fix (bug 52966)

http://xmlgraphics.apache.org/fop/Code fix by GA (fixes bug 52966) : How to use native text with EPSDocumentGraphics2D. Thanks to Luis Bernardo.

# fop-project Code fix (bug 51599)

http://xmlgraphics.apache.org/fop/Code fix by GA (fixes bug 51599) : Allow https scheme URI for PDF external action target. Thanks to Paul Huemer.

# fop-project Code fix (bug 50901)

http://xmlgraphics.apache.org/fop/Code fix by GA (fixes bug 50901) : RTF percentage table column width not calculated from table. Thanks to Carsten Pfeiffer.

# fop-project Code fix (bug 51009)

http://xmlgraphics.apache.org/fop/Code fix by GA (fixes bug 51009) : RTF generates unexpected lines for blocks in tables. Also fix three findbugs issues. Thanks to Max Aster.

# fop-project Code fix (bug 51007)

http://xmlgraphics.apache.org/fop/Code fix by GA (fixes bug 51007) : RTF tables do not support percent column-widths. Thanks to Max Aster.

# fop-project Code fix (bug 50435)

http://xmlgraphics.apache.org/fop/Code fix by GA (fixes bug 50435) : Access denied (java.util.PropertyPermission org.apache.fop.fo.properties.use-cache read). Thanks to Armin Haaf.

# fop-project Code fix (bug 49763)

http://xmlgraphics.apache.org/fop/Code fix by GA (fixes bug 49763) : Incorrect message when encountering a block in an inline in a footnote. Thanks to Adrian Buza.

# fop-project Code fix (bug 47380)

http://xmlgraphics.apache.org/fop/Code fix by GA (fixes bug 47380) : Specified rule-thickness applies only when leader-pattern is rule, otherwise should use default thickness. Thanks to Georg Datterl.

# fop-project Code fix (bug 49302)

http://xmlgraphics.apache.org/fop/Code fix by GA (fixes bug 49302) : Eliminate duplicate code. Thanks to Julien Aymé.

# fop-project Code fix (bug 49350)

http://xmlgraphics.apache.org/fop/Code fix by GA (fixes bug 49350) : Correct coding error in AFPResourceLevel#equals. Thanks to Julien Aymé.

# fop-project Code fix (bug 51836)

http://xmlgraphics.apache.org/fop/Code fix by GA (fixes bug 51836) : Throw IFException instead of NPE if navigation target (page reference) doesn't exist. Thanks to Melanie Drake.

# fop-project Code fix (bug 51808)

http://xmlgraphics.apache.org/fop/Code fix by GA (fixes bug 51808) : Fixed memory waste in traits map. Thanks to Sergey Vladimirov.

# fop-project Code fix (bug 51807)

http://xmlgraphics.apache.org/fop/Code fix by GA (fixes bug 51807) : Fixed small memory waste in rowCells array construction. Thanks to Sergey Vladimirov.

# fop-project Code fix (bug 53005)

http://xmlgraphics.apache.org/fop/Code fix by GA (fixes bug 53005) : Fixed incorrect rejection of fo:wrapper inside fo:inline inside fo:footnote-body. Thanks to Alberto Simőes.

# fop-project Code add

http://xmlgraphics.apache.org/fop/Code add by VH : Added support for PDF Object Streams. When accessibility is enabled and PDF version 1.5 selected, the structure tree will be stored in object streams in order to reduce the size of the final PDF. Thanks to Peter Hancock.

# fop-project Code fix (bug 46962)

http://xmlgraphics.apache.org/fop/Code fix by VH (fixes bug 46962) : Fixed deadlock in PropertyCache. Thanks to Alexios Giotis.

# fop-project Config add (bug 51385)

http://xmlgraphics.apache.org/fop/Config add by VH (fixes bug 51385) : Added configuration option to set the version of the output PDF document. Thanks to Mehdi Houshmand.

# fop-project Code fix (bug 52849)

http://xmlgraphics.apache.org/fop/Code fix by MH (fixes bug 52849) : Fixed bug that caused a configured and installed SVG font to be stroked, also added an event indicating when fonts are stroked. Thanks to Luis Bernardo.

# fop-project Code fix

http://xmlgraphics.apache.org/fop/Code fix by PH : Fix of a bug introduced when merging ImproveAccessibility.

# fop-project Code add (bug 50391)

http://xmlgraphics.apache.org/fop/Code add by PH (fixes bug 50391) : Improved support for empty flow-name mapping.

# fop-project Layout add (bug 32789, 49008, 49687)

http://xmlgraphics.apache.org/fop/Layout add by GA (fixes bug 32789, 49008, 49687) : Add support for complex scripts, including: full bidi support, support for advanced typographic tables, advanced support for number conversion.

# fop-project Fonts add

http://xmlgraphics.apache.org/fop/Fonts add by GA : Add support for OpenType advanced typographic tables (GDEF, GSUB, GPOS).

# fop-project Code fix (bug 52655)

http://xmlgraphics.apache.org/fop/Code fix by VH (fixes bug 52655) : Fixed rendering of special glyphs when using single-byte encoding mode. Thanks to Luis Bernardo.

# fop-project Code add

http://xmlgraphics.apache.org/fop/Code add by PH : Improvements of the Accessibility features. Thanks to Vincent Hennebert.

# fop-project Code add (bug 52416)

http://xmlgraphics.apache.org/fop/Code add by CB (fixes bug 52416) : Suppress unnecessary "font not found warnings" when generating AFP with raster fonts Thanks to Luis Bernardo.

# fop-project Code add (bug 51209)

http://xmlgraphics.apache.org/fop/Code add by CB (fixes bug 51209) : SVG text in AFP creates miscoded GOCA text Thanks to Luis Bernardo.

# fop-project Code add (bug 50391)

http://xmlgraphics.apache.org/fop/Code add by CB (fixes bug 50391) : Add support for different flow-name of fo:region-body in FOP Thanks to Peter Hancock.

# fop-project Code add (bug 51664)

http://xmlgraphics.apache.org/fop/Code add by CB (fixes bug 51664) : Tagged PDF performance improvement plus tests Thanks to Mehdi Houshmand.

# fop-project Code add (bug 52197)

http://xmlgraphics.apache.org/fop/Code add by MH (fixes bug 52197) : Improved AdobeStandardEncoding support in AFM files for type1 fonts

# fop-project Code add (bug 52151)

http://xmlgraphics.apache.org/fop/Code add by VH (fixes bug 52151) : Added ant script to get JaCoCo code coverage. Thanks to Mehdi Houshmand.

# fop-project Code add (bug 52136)

http://xmlgraphics.apache.org/fop/Code add by VH (fixes bug 52136) : Added to build file JUnit target that uses a regex to run all of the test cases. This reduces the risk that some of them are omitted when building FOP. Thanks to Mehdi Houshmand.

# fop-project Code add (bug 52089)

http://xmlgraphics.apache.org/fop/Code add by PH (fixes bug 52089) : Allow JPEG images to be embedded in an AFP document as is, without being decoded and encoded. Thanks to Mehdi Houshmand.

# fop-project Code add (bug 52010)

http://xmlgraphics.apache.org/fop/Code add by PH (fixes bug 52010) : Simplification of the build: Reduced code duplication and layout engine tests. Thanks to Mehdi Houshmand.

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by JM : Various bugfixes to make PDFDocumentGraphics2D operational again.

# fop-project Code add (bug 51962)

http://xmlgraphics.apache.org/fop/Code add by PH (fixes bug 51962) : Fix for when the last simple-page-master referenced in a page-sequence-master is not chosen when force-page-count=odd. Thanks to Mehdi Houshmand.

# fop-project Code add (bug 51928)

http://xmlgraphics.apache.org/fop/Code add by VH (fixes bug 51928) : Upgraded all tests to JUnit 4. Thanks to Mehdi Houshmand.

# fop-project Fonts fix (bug 48696)

http://xmlgraphics.apache.org/fop/Fonts fix by PH (fixes bug 48696) : Bugfix for color model in IOCA IDE structure parameter for 4- and 8-bit grayscale images. Revision 4.

# fop-project Fonts fix (bug 51760)

http://xmlgraphics.apache.org/fop/Fonts fix by PH (fixes bug 51760) : Changes the way PostScript handles Graphics2D images such that if the language is set to level 3, the image is stored as an embedded file which has no length limit. Previously it was stored as an array which has a implementation limit of 65535 elements. Thanks to Mehdi Houshmand.

# fop-project Fonts fix (bug 51759)

http://xmlgraphics.apache.org/fop/Fonts fix by PH (fixes bug 51759) : PDFFactory responsible for asdigning name to a subset font. Thanks to Mehdi Houshmand.

# fop-project Fonts fix (bug 51530)

http://xmlgraphics.apache.org/fop/Fonts fix by PH (fixes bug 51530) : Improved support for EBCDIC encoded double byte fonts fo AFP. Thanks to Mehdi Houshmand.

# fop-project Fonts fix (bug 51205)

http://xmlgraphics.apache.org/fop/Fonts fix by PH (fixes bug 51205) : Corrected typographical errors in AFPBase12FontCollection. Thanks to Mehdi Houshmand.

# fop-project Renderers fix (bug 48062)

http://xmlgraphics.apache.org/fop/Renderers fix by PH (fixes bug 48062) : Improved fix of a bug relating to PCL painter thread safetly. Previous fix in rev 895012 worked by synchronizing methods of a static instance of Java2DFontMetrics. This fix uses a unique instance for per thread.

# fop-project Renderers fix

http://xmlgraphics.apache.org/fop/Renderers fix by PH : Fixed a bug in AFP where an ArrayOutofBoundsException is throwqn when embedding a Page Segment.

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by VH : Added support for 128bit encryption in PDF output. Thanks to Michael Rubin.

# fop-project Renderers fix

http://xmlgraphics.apache.org/fop/Renderers fix by PH : Fixed a bug in AFP where the object area axes of an Include Object was incorrectly set when rotated by 180.

# fop-project Fonts fix (bug 51596)

http://xmlgraphics.apache.org/fop/Fonts fix by JM (fixes bug 51596) : Fixed a bug in TTF subsetting where a composite glyph could get remapped more than once resulting in garbled character. Thanks to Mehdi Houshmand.

# fop-project Fonts fix (bug 50605)

http://xmlgraphics.apache.org/fop/Fonts fix by JM (fixes bug 50605) : Fixed a number of bugs concerning Type 1 and other single-byte fonts (glyph width mismatches and overlapping characters).

# fop-project Renderers fix

http://xmlgraphics.apache.org/fop/Renderers fix by JM : Fixed a multi-threading bug for SVG images included through svg:image inside SVG documents.

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by PH : Added an IFDocumentHandler filter for triggering rendering events. Created an Event that captures an end page event with the page number.

# fop-project Renderers fix

http://xmlgraphics.apache.org/fop/Renderers fix by VH : Fix for alternative text not working in tagged PDF for TIFF images.

# fop-project Renderers fix (bug 50909)

http://xmlgraphics.apache.org/fop/Renderers fix by PH (fixes bug 50909) : Fixed io exception in MODCAParser caused by the improper use of mark() and reset() on the MODCA data input stream. Added unit test.

# fop-project Fonts fix (bug 51144)

http://xmlgraphics.apache.org/fop/Fonts fix by JM (fixes bug 51144) : Removed invalid entries in ToUnicode table of CID subset fonts. Thanks to Mehdi Houshmand.

# fop-project Renderers fix (bug 50899)

http://xmlgraphics.apache.org/fop/Renderers fix by JM (fixes bug 50899) : Fixed mapping of font weights between CSS values and TextAttribute.WEIGHT_*. Thanks to Glenn Adams.

# fop-project Renderers fix

http://xmlgraphics.apache.org/fop/Renderers fix by JM : AFP GOCA: fonts were not embedded from within AFPGraphics2D.

# fop-project Renderers fix

http://xmlgraphics.apache.org/fop/Renderers fix by JM : AFP GOCA: Changed the way FOP fonts are selected based on Batik's GVT fonts to match the behaviour of PDF/PS output.

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by JM : Added option to place AFP NOPs right before the end of a named page group (page-sequence), rather than after the start.

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by JM : Added option for PostScript output to optimize for file size rather than quality.

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by JM : AFP GOCA: Added option to disable GOCA and to control text painting inside GOCA graphics.

# fop-project Renderers fix

http://xmlgraphics.apache.org/fop/Renderers fix by JM : AFP GOCA: Work-around for InfoPrint's AFP implementation which seems to lose the character set state over Graphics Data (GAD) boundaries.

# fop-project Renderers fix

http://xmlgraphics.apache.org/fop/Renderers fix by JM : Bugfix for AFP GOCA segments: they were not properly marked as appended which could lead to graphics state changes in some implementations.

# fop-project Renderers fix (bug 51010)

http://xmlgraphics.apache.org/fop/Renderers fix by CB (fixes bug 51010) : Bugzilla 51010: Bookmarks create useless lines in RTF Thanks to Max Aster.

# fop-project Renderers fix (bug 51008)

http://xmlgraphics.apache.org/fop/Renderers fix by CB (fixes bug 51008) : Bugzilla 51008: page-number-citation-last does not work in RTF Thanks to Max Aster.

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by VH : Added id element to intermediate format to track the origin of content.

# fop-project Renderers fix (bug 50987)

http://xmlgraphics.apache.org/fop/Renderers fix by AD (fixes bug 50987) : Bugzilla 50988: Fixed a NullPointerException in case a white-space fo:character was removed due to white-space handling. Thanks to Matthias Reischenbacher.

# fop-project Renderers fix (bug 50987)

http://xmlgraphics.apache.org/fop/Renderers fix by AD (fixes bug 50987) : Bugzilla 50987: Fixed an issue in PDF output where a link was added to the parent tree instead of the related structure element. Thanks to Martin Koegler.

# fop-project Renderers fix (bug 50986)

http://xmlgraphics.apache.org/fop/Renderers fix by AD (fixes bug 50986) : Bugzilla 50986: Fixed an issue where invalid PDF page content was generated due to incorrect ET/EMC sequences. Thanks to Martin Koegler.

# fop-project Code fix (bug 50593)

http://xmlgraphics.apache.org/fop/Code fix by AD (fixes bug 50593) : Fixed regression introduced by Bugzilla 50593: bookmarks pointing to a non-existing internal destination should just trigger a warning.

# fop-project Layout fix (bug 50965)

http://xmlgraphics.apache.org/fop/Layout fix by AD (fixes bug 50965) : Bugzilla 50965: Fixed a regression in BlockContainerLayoutManager where margins were no longer reset after forced breaks. Thanks to Martin Koegler.

# fop-project Layout fix

http://xmlgraphics.apache.org/fop/Layout fix by VH : Implemented non-standard behavior for basic-link areas, such that they take into account the heights of their descendants areas.

# fop-project Layout fix

http://xmlgraphics.apache.org/fop/Layout fix by VH : Fix for keep-together does not apply to fo:table-cell.

# fop-project Layout fix

http://xmlgraphics.apache.org/fop/Layout fix by VH : Fix for keep-together on a table containing row-spanning cells that was not honored.

# fop-project Layout fix (bug 50196)

http://xmlgraphics.apache.org/fop/Layout fix by VH (fixes bug 50196) : Fix forpadding-start ignored when table-header/footer is repeated. Thanks to Matthias Reischenbacher.

# fop-project Renderers fix

http://xmlgraphics.apache.org/fop/Renderers fix by JM : Increased maximum possible PDF size from 2GB to around 9GB (hard maximum imposed by the PDF specification).

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by JM : Added support for CIE Lab colors (from XSL-FO 2.0 WD).

# fop-project Renderers add (bug 49403)

http://xmlgraphics.apache.org/fop/Renderers add by JM (fixes bug 49403) : Initial work on spot colors (aka named colors) for PDF output. Thanks to Patrick Jaromin.

# fop-project Renderers fix (bug 50705)

http://xmlgraphics.apache.org/fop/Renderers fix by JM (fixes bug 50705) : Fix to preserve the order of AFP TLEs and NOPs as given in the XSL-FO document. Thanks to Mehdi Houshmand.

# fop-project Fonts add (bug 50699)

http://xmlgraphics.apache.org/fop/Fonts add by JM (fixes bug 50699) : Added support for lookup of alternative glyphs when additional single-byte encodings are used, ex. replacing "Omegagreek" by "Omega" and vice versa. Thanks to Alexandros Papadakis.

# fop-project Code add (bug 48334)

http://xmlgraphics.apache.org/fop/Code add by AD (fixes bug 48334) : Added support for resolution of relative URIs against a specified xml:base during property refinement.

# fop-project Renderers add

http://xmlgraphics.apache.org/fop/Renderers add by JM : Allow afp:no-operation to also appear under fo:page-sequence and fo:declarations.

# fop-project Code fix (bug 50635)

http://xmlgraphics.apache.org/fop/Code fix by AD (fixes bug 50635) : Fix for issue in RenderPagesModel.checkPreparedPages() where the same page-sequence is potentially started multiple times. Thanks to Martin Koegler.

# fop-project Code fix (bug 50636)

http://xmlgraphics.apache.org/fop/Code fix by AD (fixes bug 50636) : Fix for performance issue when adding pages, if the total number of pages is significantly large. Thanks to Martin Koegler.

# fop-project Code fix (bug 50626)

http://xmlgraphics.apache.org/fop/Code fix by AD (fixes bug 50626) : Fix for performance issue when adding nodes, if the number of children is significantly large. Thanks to Martin Koegler.

# fop-project Config fix

http://xmlgraphics.apache.org/fop/Config fix by SP : Fix for relative URIs in the configuration file (base, font-base, hyphenation-base) are evaluated relative to the base URI of the configuration file.

# fop-project Layout fix (bug 49848)

http://xmlgraphics.apache.org/fop/Layout fix by AD (fixes bug 49848) : Fix for correct behavior of keep-together.within-line in case there are nested inlines

# fop-project Code fix (bug 50471)

http://xmlgraphics.apache.org/fop/Code fix by AD (fixes bug 50471) : Fix for avoid ArrayIndexOutOfBoundsException for codepoints without a linebreak class

# fop-project Layout fix (bug 48380)

http://xmlgraphics.apache.org/fop/Layout fix by AD (fixes bug 48380) : Fix for avoid ClassCastException when using fox:widow-content-limit

# fop-project Layout fix (bug 50089)

http://xmlgraphics.apache.org/fop/Layout fix by VH (fixes bug 50089) : Fix for content after forced break in block-container is not rendered.

# fop-project Layout fix (bug 42034)

http://xmlgraphics.apache.org/fop/Layout fix by JM (fixes bug 42034) : Fixed adjustment of inline parent area for justified text containing a forward page reference.

# fop-project Layout fix (bug 38264)

http://xmlgraphics.apache.org/fop/Layout fix by AD (fixes bug 38264) : Fixed behavior when combining hyphenation with preserved linefeeds or whitespace.

# fop-project Code fix (bug 49695)

http://xmlgraphics.apache.org/fop/Code fix by VH (fixes bug 49695) : Replaced magic numbers with constants from UnitConv and GraphicsConstants. Thanks to Joshua Marquart.

# fop-project Renderers add (bug 42600)

http://xmlgraphics.apache.org/fop/Renderers add by JM (fixes bug 42600) : Added some support for break-before/-after for RTF output. Thanks to Max Aster.

# fop-project Renderers add (bug 49379)

http://xmlgraphics.apache.org/fop/Renderers add by JM (fixes bug 49379) : Added ability to embed an external AFP page segment resource file (AFP output only). Thanks to Peter Hancock.

# fop-project Renderers fix (bug 46360)

http://xmlgraphics.apache.org/fop/Renderers fix by JM (fixes bug 46360) : Fixed a multi-threading issue when rendering SVG. Thanks to Alexios Giotis.

# fop-project Layout fix (bug 49885)

http://xmlgraphics.apache.org/fop/Layout fix by JM (fixes bug 49885) : Fixed retrieval of available BPD for cases spanning columns and multiple pages with differing page masters.

# fop-project Renderers remove

http://xmlgraphics.apache.org/fop/Renderers remove by VH : Removed old Renderer implementations for those output formats that have a version based on the new DocumentHandler architecture available (AFP, PCL, PDF, PS).

# fop-project Fonts fix

http://xmlgraphics.apache.org/fop/Fonts fix by AC : Reinstated support for being able to specify a font cache filepath in the fop user configuration.

# fop-project Fonts add

http://xmlgraphics.apache.org/fop/Fonts add by AC : Added convenience support for the flushing of the Fop font cache file from the command line.

# fop-project Renderers add (bug 44460)

http://xmlgraphics.apache.org/fop/Renderers add by JM (fixes bug 44460) : Added support for PDF File Attachments (Embedded Files). Thanks to Andrejus Chaliapinas.